# addons/eventscripts/buildmod/buildmod.py

# |BuildMod| Beta 1
# written by isivisi and McBoo for the buildmod server

import es
import playerlib
import vecmath
import gamethread
import effectlib
from mcolormsglib import mcolormsg
import random

npcs = ['gman', 'dog', 'alyx', 'barney', 'antlion', 'antlionguard', 'breen', 'combine_camera', 'crow', 'cscanner', 'eli', 'headcrab', 'headcrabfast', 'kleiner', 'manhack', 'monk', 'pigeon', 'rollermine', 'seagull', 'strider', 'vortigaunt', 'turret_floor', 'turret_ceiling']

nodelete = ['world', 'info_player_start', 'info_player_deathmatch', 'info_player_rebel', 'info_player_combine', 'worldspawn', 'player', 'team_manager']

admins = []

def b_addadmin(): admins.append(es.getargs())
es.regcmd('b_addadmin', 'buildmod/b_addadmin')

def getbuilds(): entity.getBuilds(es.getcmduserid())
es.regsaycmd('!builds', 'buildmod/getbuilds')

es.server.queuecmd('exec admins')

def adminlist():
	text = 'Admins online are:'
	for i in es.getUseridList():
		if es.getplayersteamid(i) in admins:
			text + ', %s'%es.getplayername(i)
	notify(i, text)
es.regsaycmd('!admins', 'buildmod/adminlist')
	
def disablebuilding():
	if es.getplayersteamid(es.getcmduserid()) in admins:
		entity.setVar('allow_build', 0)
	else:
		notify(es.getcmduserid(), 'You are not an admin, you cannot use this command!')
es.regclientcmd('b_disablebuilding', 'buildmod/disablebuilding')

def enablebuilding():
	if es.getplayersteamid(es.getcmduserid()) in admins:
		entity.setVar('allow_build', 1)
	else:
		notify(es.getcmduserid(), 'You are not an admin, you cannot use this command!')
es.regclientcmd('b_enablebuilding', 'buildmod/enablebuilding')

es.keygroupload('props', '|buildmod')

es.keygroupload('playersaves', '|buildmod')
if es.keygetvalue('playersaves', 'def', 'save'): None
else:
	es.keygroupcreate('playersaves')
	es.keycreate('playersaves', 'def')
	es.keysetvalue('playersaves', 'def', 'save', '1')
	es.keygroupsave('playersaves', '|buildmod')
es.keygroupload('propsaves', '|buildmod')
if es.keygetvalue('propsaves', 'def', 'save'): None
else:
	es.keygroupcreate('propsaves')
	es.keycreate('propsaves', 'def')
	es.keysetvalue('propsaves', 'def', 'save', '1')
	es.keygroupsave('propsaves', '|buildmod')
	
def unload():
	es.keygroupdelete('propsaves')
	es.keygroupdelete('playersaves')
	
def player_activate(ev):
	entity.playerCheck(ev['userid'])

def player_spawn(ev):
	es.server.queuecmd('mp_disable_autokick %'%ev['userid'])
	playerlib.getPlayer(ev['userid']).color = entity.getPlayerColor(ev['userid'])
	

class entity():
	
	def __init__(self):
		self.owner = {}
		self.playerSaves = {}
		self.playerChecked = {}
		self.propmodel = {}
		self.playerColor = {}
		self.vars = {'allow_build': 1}
		
	def getBuilds(self, userid):
		notify(userid, 'displaying all builds:')
		for build in self.playerSaves[es.getplayersteamid(userid)]:
			es.tell(userid, '%s (%s props)'%(build, es.keygetvalue('propsaves', build, 'props')))
			
		
	def setVar(self, var, value):
		self.vars[var] = value
		notify_var('buildmod server variable %s set to : %s'%(var, value))
		
	def setPlayerColor(self, userid): self.playerColor[int(userid)] = [random.randint(1,255), random.randint(1,255), random.randint(1,255)]
	
	def getPlayerColor(self, userid): 
		try:
			return self.playerColor[int(userid)]
		except:
			self.playerColor[int(userid)] = [random.randint(1,255), random.randint(1,255), random.randint(1,255)]
			return self.playerColor[int(userid)]
		
	def deleteProp(self, userid, all):
		if all == 1:
			props = 0
			for prop in self.owner:
				if self.owner[prop] == es.getplayersteamid(userid):
					if es.entitygetvalue(prop, 'classname'):
						props += 1
						es.remove(prop)
			notify(userid, '%s props removed'%props)
		else:
			es.sexec(userid, 'ent_delete')
			x,y,z = playerlib.getPlayer(userid).location
			x2,y2,z2 = str(playerlib.getPlayer(userid).viewcoord).split(",")
			effectlib.drawLine((x,y,z), (x2,y2,z2), 'materials/sprites/laser.vmt', 'materials/sprites/halo01.vmt', 1, 10, 10, self.playerColor[int(userid)][0], self.playerColor[int(userid)][1], self.playerColor[int(userid)][2], 255, 100, 0, 0, 0, 0)

	def setMotion(self, userid, value):
		name = random.randint(1, 99999)
		es.entsetname(userid, name)
		es.fire(userid, name, '%smotion'%value)
		
	def playerCheck(self, userid):
		try: 
			if self.playerChecked[es.getplayersteamid(userid)] != 1:None
		except: self.playerChecked[es.getplayersteamid(userid)] = 0
		if self.playerChecked[es.getplayersteamid(userid)] != 1:
			if es.keygetvalue('playersaves', es.getplayersteamid(userid), 'next'):
				looping = 1
				self.playerSaves[es.getplayersteamid(userid)] = []
				self.playerChecked[es.getplayersteamid(userid)] = 1
				while 1:
					if es.keygetvalue('playersaves', es.getplayersteamid(userid), looping):
						self.playerSaves[es.getplayersteamid(userid)].append(es.keygetvalue('playersaves', es.getplayersteamid(userid), looping))
						looping += 1
					else: break
			else:
				self.playerSaves[es.getplayersteamid(userid)] = []
				self.playerChecked[es.getplayersteamid(userid)] = 1
			
	
	def makeSave(self, userid, buildname):
		if es.keygetvalue('propsaves', buildname, 'props'): next = int(es.keygetvalue('propsaves', buildname, 'props'))
		else: next = 1
		print next
		es.keycreate('propsaves', buildname)
		for prop in self.owner:
			if self.owner[prop] == es.getplayersteamid(userid):
				if es.entitygetvalue(prop, 'model'):
					es.keysetvalue('propsaves', buildname, '%s_model'%next, '%s'%self.propmodel[prop])
					es.keysetvalue('propsaves', buildname, '%s_origin'%next, '%s'%es.entitygetvalue(prop, 'origin'))
					es.keysetvalue('propsaves', buildname, '%s_angles'%next, '%s'%es.entitygetvalue(prop, 'angles'))
					next += 1
		notify(userid, '%s props saved in build %s'%(next - 1, buildname))
		es.keysetvalue('propsaves', buildname, 'props', next)
		es.keygroupsave('propsaves', '|buildmod')
		if buildname in self.playerSaves[es.getplayersteamid(userid)]: None
		else:
			self.playerSaves[es.getplayersteamid(userid)].append(buildname)
			if es.keygetvalue('playersaves', es.getplayersteamid(userid), 'next'):
				next = int(es.keygetvalue('playersaves', es.getplayersteamid(userid), 'next'))
				es.keysetvalue('playersaves', es.getplayersteamid(userid), next, buildname)
				next += 1
				es.keysetvalue('playersaves', es.getplayersteamid(userid), 'next', next)
				es.keygroupsave('playersaves', '|buildmod')
			else:
				es.keycreate('playersaves', es.getplayersteamid(userid))
				es.keysetvalue('playersaves', es.getplayersteamid(userid), '1', buildname)
				es.keysetvalue('playersaves', es.getplayersteamid(userid), 'next', '2')
				es.keygroupsave('playersaves', '|buildmod')
		
	def loadSave(self, userid, buildname):
		if self.vars['allow_build'] == 1:
			if buildname in self.playerSaves[es.getplayersteamid(userid)]:
				if es.keygetvalue('propsaves', buildname, 'props'):
					currentprop = 0
					while 1:
						currentprop += 1
						print currentprop
						propModel = es.keygetvalue('propsaves', buildname, '%s_model'%currentprop)
						propOrigin = es.keygetvalue('propsaves', buildname, '%s_origin'%currentprop)
						propAngles = es.keygetvalue('propsaves', buildname, '%s_angles'%currentprop)
						if propModel:
							name = random.randint(1, 999999)
							index = es.createentity('prop_physics')
							es.entitysetvalue(index, 'model', propModel)
							es.entitysetvalue(index, 'origin', propOrigin)
							es.entitysetvalue(index, 'angles', propAngles)
							es.entitysetvalue(index, 'classname', name)
							es.spawnentity(index)
							es.fire(userid, name, 'disablemotion')
						else:
							notify(userid, '%s spawned with %s props'%(buildname,currentprop - 1))
							break
			else:
				notify(userid, 'build does not exist')
	
	def nodelete(self, userid):
		for entity in nodelete:
			es.fire(userid, nodelete, 'addoutput', 'classname %s'%nodelete)
			es.fire(userid, nodelete, 'addoutput', 'targetname %s'%nodelete)
		
	def setColor(self, userid, color):
		entity.nodelete(userid)
		es.entsetname(userid, color)
		entity.nodelete(userid)
		es.fire(userid, color, 'color', color)
		es.fire(userid, color, 'addoutput', 'classname color_finish')
	
	def setRelationship(self, userid, relationship):
		name = random.randint(1, 99999)
		es.entsetname(userid, name)
		es.fire(userid, name, 'setrelationship', 'Player D_%s 99'%relationship)
		es.fire(userid, name, 'addoutput', 'classname done_relationship')
		
	def spawnNPC(self, userid, item):
		if self.vars['allow_build'] == 1:
			if item in npcs:
				index = es.createentity('npc_%s'%item)
				coord = str(playerlib.getPlayer(userid).viewcoord).replace(",", " ")
				es.entitysetvalue(index, 'origin', coord)
				es.spawnentity(index)
			else: notify(userid, 'cannot spawn that npc')
				
	def spawnItem(self, userid, item):
		if self.vars['allow_build'] == 1:
			item_check = es.keygetvalue('props', item, 'model')
			if item_check:
				indexphysics = es.createentity('prop_physics')
				self.propmodel[indexphysics] = 'models/%s'%item_check
				es.entitysetvalue(indexphysics, 'model', 'models/%s'%item_check)
				es.entitysetvalue(indexphysics, 'solid', '2')
				es.entitysetvalue(indexphysics, 'classname', 'prop_%s'%userid)
				coord = str(playerlib.getPlayer(userid).viewcoord).replace(",", " ")
				es.entitysetvalue(indexphysics, 'origin', coord)
				es.spawnentity(indexphysics)
				es.fire(userid, 'prop_%s'%userid, 'disablemotion')
				for x in es.createentitylist():
					if es.entitygetvalue(x, 'classname') == 'prop_%s'%userid:
						self.owner[x] = es.getplayersteamid(userid)
						es.fire(userid, 'prop_%s'%userid, 'addoutput', 'classname prop_physics')
			else: notify(userid, 'prop not found in database!')

entity = entity()

def enablemotion(): entity.setMotion(es.getcmduserid(), 'enable')
def disablemotion(): entity.setMotion(es.getcmduserid(), 'disable')
es.regsaycmd('!freezeprop', 'buildmod/disablemotion')
es.regsaycmd('!unfreezeprop', 'buildmod/enablemotion')
	
def notify(userid, text): 
	text2 = mcolormsg('|BuildMod|')
	text2.create('|BuildMod| %s'%text,0,191,255)
	text2.tell(userid)
	
def notify_var(text): 
	text2 = mcolormsg('|BuildMod|')
	text2.create('|BuildMod| %s'%text,255,0,0)
	text2.msg()
	
def color(): entity.setColor(es.getcmduserid(), es.getargs())
es.regsaycmd('!color', 'buildmod/color')

def delete():
	if es.getargs() == 'all': entity.deleteProp(es.getcmduserid(), 1)
	else: entity.deleteProp(es.getcmduserid(), 0)
es.regsaycmd('!del', 'buildmod/delete')

def save(): entity.makeSave(es.getcmduserid(), es.getargs())
es.regsaycmd('!save', 'buildmod/save')

def loads(): entity.loadSave(es.getcmduserid(), es.getargs())
es.regsaycmd('!load', 'buildmod/loads')

def spawn(): entity.spawnItem(es.getcmduserid(), es.getargs())
es.regsaycmd('!s', 'buildmod/spawn')

def npc(): entity.spawnNPC(es.getcmduserid(), es.getargs())
es.regsaycmd('!npc', 'buildmod/npc')

def relationship():
	if es.getargs():
		if es.getargs() == 'hate': entity.setRelationship(es.getcmduserid(), 'ht')
		elif es.getargs() == 'like': entity.setRelationship(es.getcmduserid(), 'li')
		elif es.getargs() == 'fear': entity.setRelationship(es.getcmduserid(), 'fr')
		elif es.getargs() == 'neutral': entity.setRelationship(es.getcmduserid(), 'nl')
es.regsaycmd('!relationship', 'buildmod/relationship')

for i in es.getUseridList():
	entity.playerCheck(i)
	entity.setPlayerColor(i)